#setwd("/Users/user/OneDrive\ -\ Wageningen\ University\ &\ Research/mitotic_recomb/")

if(Sys.getenv("USERNAME")=="auxie001"){setwd("C:\\Users\\auxie001\\OneDrive - WageningenUR\\mitotic_recomb")}

# VCF Filtering -----------------------------------------------------------
library(vcfR)
library(ggplot2)
library(tidyr)
library(dplyr)
hetdip <- read.vcfR("afum_primitive.vcf.gz")

gt <- as.data.frame(extract.gt(hetdip))

#First we filter to remove heterozygotes in the starting strains
het_test <- as.data.frame(is.het(extract.gt(hetdip)))

no_het <- gt[which(het_test$foc142 == F & het_test$foc137 == F),]

#collect which are 0/0 and 1/1 in focal strains

var_137 <- which(no_het$foc137 == "1/1" & no_het$foc142 == "0/0" & no_het$ZJH1 == "0/1")
var_142 <- which(no_het$foc137 == "0/0" & no_het$foc142 == "1/1" & no_het$ZJH1 == "0/1")
#now combine and sort
vars <- sort(c(var_137,var_142))
final <- no_het[vars,]
seg_final <- final[which(final$foc137 != final$foc142),]

seg_final$contig <- gsub("_.*","",row.names(seg_final))
seg_final$position <- gsub(".*_","",row.names(seg_final))

#seg_final <- seg_final[sample(nrow(seg_final),150),]
head(seg_final)

#now we polarize the variants
seg_final$hap1[seg_final$foc137 == "0/0" & seg_final$hap1 == "0/0"] <- "A"
seg_final$hap1[seg_final$foc137 == "0/0" & seg_final$hap1 == "1/1"] <- "B"
seg_final$hap1[seg_final$foc137 == "1/1" & seg_final$hap1 == "0/0"] <- "B"
seg_final$hap1[seg_final$foc137 == "1/1" & seg_final$hap1 == "1/1"] <- "A"

seg_final$hap4[seg_final$foc137 == "0/0" & seg_final$hap4 == "0/0"] <- "A"
seg_final$hap4[seg_final$foc137 == "0/0" & seg_final$hap4 == "1/1"] <- "B"
seg_final$hap4[seg_final$foc137 == "1/1" & seg_final$hap4 == "0/0"] <- "B"
seg_final$hap4[seg_final$foc137 == "1/1" & seg_final$hap4 == "1/1"] <- "A"

seg_final$hap5[seg_final$foc137 == "0/0" & seg_final$hap5 == "0/0"] <- "A"
seg_final$hap5[seg_final$foc137 == "0/0" & seg_final$hap5 == "1/1"] <- "B"
seg_final$hap5[seg_final$foc137 == "1/1" & seg_final$hap5 == "0/0"] <- "B"
seg_final$hap5[seg_final$foc137 == "1/1" & seg_final$hap5 == "1/1"] <- "A"

seg_final$hap6[seg_final$foc137 == "0/0" & seg_final$hap6 == "0/0"] <- "A"
seg_final$hap6[seg_final$foc137 == "0/0" & seg_final$hap6 == "1/1"] <- "B"
seg_final$hap6[seg_final$foc137 == "1/1" & seg_final$hap6 == "0/0"] <- "B"
seg_final$hap6[seg_final$foc137 == "1/1" & seg_final$hap6 == "1/1"] <- "A"

seg_final$hap7[seg_final$foc137 == "0/0" & seg_final$hap7 == "0/0"] <- "A"
seg_final$hap7[seg_final$foc137 == "0/0" & seg_final$hap7 == "1/1"] <- "B"
seg_final$hap7[seg_final$foc137 == "1/1" & seg_final$hap7 == "0/0"] <- "B"
seg_final$hap7[seg_final$foc137 == "1/1" & seg_final$hap7 == "1/1"] <- "A"

seg_final$hap9[seg_final$foc137 == "0/0" & seg_final$hap9 == "0/0"] <- "A"
seg_final$hap9[seg_final$foc137 == "0/0" & seg_final$hap9 == "1/1"] <- "B"
seg_final$hap9[seg_final$foc137 == "1/1" & seg_final$hap9 == "0/0"] <- "B"
seg_final$hap9[seg_final$foc137 == "1/1" & seg_final$hap9 == "1/1"] <- "A"

seg_final$hap10[seg_final$foc137 == "0/0" & seg_final$hap10 == "0/0"] <- "A"
seg_final$hap10[seg_final$foc137 == "0/0" & seg_final$hap10 == "1/1"] <- "B"
seg_final$hap10[seg_final$foc137 == "1/1" & seg_final$hap10 == "0/0"] <- "B"
seg_final$hap10[seg_final$foc137 == "1/1" & seg_final$hap10 == "1/1"] <- "A"

seg_final$hap11[seg_final$foc137 == "0/0" & seg_final$hap11 == "0/0"] <- "A"
seg_final$hap11[seg_final$foc137 == "0/0" & seg_final$hap11 == "1/1"] <- "B"
seg_final$hap11[seg_final$foc137 == "1/1" & seg_final$hap11 == "0/0"] <- "B"
seg_final$hap11[seg_final$foc137 == "1/1" & seg_final$hap11 == "1/1"] <- "A"

seg_final$hap12[seg_final$foc137 == "0/0" & seg_final$hap12 == "0/0"] <- "A"
seg_final$hap12[seg_final$foc137 == "0/0" & seg_final$hap12 == "1/1"] <- "B"
seg_final$hap12[seg_final$foc137 == "1/1" & seg_final$hap12 == "0/0"] <- "B"
seg_final$hap12[seg_final$foc137 == "1/1" & seg_final$hap12 == "1/1"] <- "A"

seg_final$hap13[seg_final$foc137 == "0/0" & seg_final$hap13 == "0/0"] <- "A"
seg_final$hap13[seg_final$foc137 == "0/0" & seg_final$hap13 == "1/1"] <- "B"
seg_final$hap13[seg_final$foc137 == "1/1" & seg_final$hap13 == "0/0"] <- "B"
seg_final$hap13[seg_final$foc137 == "1/1" & seg_final$hap13 == "1/1"] <- "A"

seg_final$hap14[seg_final$foc137 == "0/0" & seg_final$hap14 == "0/0"] <- "A"
seg_final$hap14[seg_final$foc137 == "0/0" & seg_final$hap14 == "1/1"] <- "B"
seg_final$hap14[seg_final$foc137 == "1/1" & seg_final$hap14 == "0/0"] <- "B"
seg_final$hap14[seg_final$foc137 == "1/1" & seg_final$hap14 == "1/1"] <- "A"

seg_final$hap15[seg_final$foc137 == "0/0" & seg_final$hap15 == "0/0"] <- "A"
seg_final$hap15[seg_final$foc137 == "0/0" & seg_final$hap15 == "1/1"] <- "B"
seg_final$hap15[seg_final$foc137 == "1/1" & seg_final$hap15 == "0/0"] <- "B"
seg_final$hap15[seg_final$foc137 == "1/1" & seg_final$hap15 == "1/1"] <- "A"

seg_final$hap16[seg_final$foc137 == "0/0" & seg_final$hap16 == "0/0"] <- "A"
seg_final$hap16[seg_final$foc137 == "0/0" & seg_final$hap16 == "1/1"] <- "B"
seg_final$hap16[seg_final$foc137 == "1/1" & seg_final$hap16 == "0/0"] <- "B"
seg_final$hap16[seg_final$foc137 == "1/1" & seg_final$hap16 == "1/1"] <- "A"

seg_final$hap17[seg_final$foc137 == "0/0" & seg_final$hap17 == "0/0"] <- "A"
seg_final$hap17[seg_final$foc137 == "0/0" & seg_final$hap17 == "1/1"] <- "B"
seg_final$hap17[seg_final$foc137 == "1/1" & seg_final$hap17 == "0/0"] <- "B"
seg_final$hap17[seg_final$foc137 == "1/1" & seg_final$hap17 == "1/1"] <- "A"

seg_final$hap18[seg_final$foc137 == "0/0" & seg_final$hap18 == "0/0"] <- "A"
seg_final$hap18[seg_final$foc137 == "0/0" & seg_final$hap18 == "1/1"] <- "B"
seg_final$hap18[seg_final$foc137 == "1/1" & seg_final$hap18 == "0/0"] <- "B"
seg_final$hap18[seg_final$foc137 == "1/1" & seg_final$hap18 == "1/1"] <- "A"

seg_final$hap19[seg_final$foc137 == "0/0" & seg_final$hap19 == "0/0"] <- "A"
seg_final$hap19[seg_final$foc137 == "0/0" & seg_final$hap19 == "1/1"] <- "B"
seg_final$hap19[seg_final$foc137 == "1/1" & seg_final$hap19 == "0/0"] <- "B"
seg_final$hap19[seg_final$foc137 == "1/1" & seg_final$hap19 == "1/1"] <- "A"

seg_final$hap20[seg_final$foc137 == "0/0" & seg_final$hap20 == "0/0"] <- "A"
seg_final$hap20[seg_final$foc137 == "0/0" & seg_final$hap20 == "1/1"] <- "B"
seg_final$hap20[seg_final$foc137 == "1/1" & seg_final$hap20 == "0/0"] <- "B"
seg_final$hap20[seg_final$foc137 == "1/1" & seg_final$hap20 == "1/1"] <- "A"

seg_final$hap21[seg_final$foc137 == "0/0" & seg_final$hap21 == "0/0"] <- "A"
seg_final$hap21[seg_final$foc137 == "0/0" & seg_final$hap21 == "1/1"] <- "B"
seg_final$hap21[seg_final$foc137 == "1/1" & seg_final$hap21 == "0/0"] <- "B"
seg_final$hap21[seg_final$foc137 == "1/1" & seg_final$hap21 == "1/1"] <- "A"

seg_final$hap22[seg_final$foc137 == "0/0" & seg_final$hap22 == "0/0"] <- "A"
seg_final$hap22[seg_final$foc137 == "0/0" & seg_final$hap22 == "1/1"] <- "B"
seg_final$hap22[seg_final$foc137 == "1/1" & seg_final$hap22 == "0/0"] <- "B"
seg_final$hap22[seg_final$foc137 == "1/1" & seg_final$hap22 == "1/1"] <- "A"

seg_final$hap23[seg_final$foc137 == "0/0" & seg_final$hap23 == "0/0"] <- "A"
seg_final$hap23[seg_final$foc137 == "0/0" & seg_final$hap23 == "1/1"] <- "B"
seg_final$hap23[seg_final$foc137 == "1/1" & seg_final$hap23 == "0/0"] <- "B"
seg_final$hap23[seg_final$foc137 == "1/1" & seg_final$hap23 == "1/1"] <- "A"

seg_final$ZJH1[seg_final$foc137 == "0/0" & seg_final$ZJH1 == "0/0"] <- "A"
seg_final$ZJH1[seg_final$foc137 == "0/0" & seg_final$ZJH1 == "1/1"] <- "B"
seg_final$ZJH1[seg_final$foc137 == "1/1" & seg_final$ZJH1 == "0/0"] <- "B"
seg_final$ZJH1[seg_final$foc137 == "1/1" & seg_final$ZJH1 == "1/1"] <- "A"

seg_final$ZJH2[seg_final$foc137 == "0/0" & seg_final$ZJH2 == "0/0"] <- "A"
seg_final$ZJH2[seg_final$foc137 == "0/0" & seg_final$ZJH2 == "1/1"] <- "B"
seg_final$ZJH2[seg_final$foc137 == "1/1" & seg_final$ZJH2 == "0/0"] <- "B"
seg_final$ZJH2[seg_final$foc137 == "1/1" & seg_final$ZJH2 == "1/1"] <- "A"

seg_final$ZJH3[seg_final$foc137 == "0/0" & seg_final$ZJH3 == "0/0"] <- "A"
seg_final$ZJH3[seg_final$foc137 == "0/0" & seg_final$ZJH3 == "1/1"] <- "B"
seg_final$ZJH3[seg_final$foc137 == "1/1" & seg_final$ZJH3 == "0/0"] <- "B"
seg_final$ZJH3[seg_final$foc137 == "1/1" & seg_final$ZJH3 == "1/1"] <- "A"

seg_final$ZJH4[seg_final$foc137 == "0/0" & seg_final$ZJH4 == "0/0"] <- "A"
seg_final$ZJH4[seg_final$foc137 == "0/0" & seg_final$ZJH4 == "1/1"] <- "B"
seg_final$ZJH4[seg_final$foc137 == "1/1" & seg_final$ZJH4 == "0/0"] <- "B"
seg_final$ZJH4[seg_final$foc137 == "1/1" & seg_final$ZJH4 == "1/1"] <- "A"

seg_final$foc137[seg_final$foc137 == "0/0"] <- "A"
seg_final$foc137[seg_final$foc137 == "1/1"] <- "A"

seg_final$foc142[seg_final$foc142 == "0/0"] <- "B"
seg_final$foc142[seg_final$foc142 == "1/1"] <- "B"

seg_final[seg_final == "0/1"] <- "A/B"

#seg_final[seg_final == "./0"] <- NA
#seg_final[seg_final == "./1"] <- NA
#seg_final[seg_final == "0/0"] <- NA
#seg_final[seg_final == "1/1"] <- NA
#seg_final[seg_final == "1/2"] <- NA
#seg_final[seg_final == "0/2"] <- NA
#seg_final[seg_final == "2/2"] <- NA
#seg_final[seg_final == "1/3"] <- NA
#seg_final[seg_final == "0/3"] <- NA

seg_final[seg_final %in% c("./0","./1","0/1","1/1","1/2","0/2","2/2","1/3","0/3")]

seg_final_longer <- pivot_longer(seg_final,1:26,names_to="isolate")
seg_final_longer$position <- as.numeric(seg_final_longer$position)/1000000

unique(seg_final_longer$value)

seg_final_longer$isolate <- factor(seg_final_longer$isolate,levels=c("foc137","foc142","ZJH1","ZJH2","ZJH3","ZJH4","hap1","hap4","hap5","hap6",
                                                                        "hap7","hap9","hap10","hap11","hap12","hap13",
                                                                        "hap14","hap15","hap16","hap17","hap19","hap20","hap21",
                                                                        "hap22","hap18","hap23"))

png(paste("fumigatus_haploidized_genotypes",Sys.Date(),".png"),width=1200,height=600)
ggplot(seg_final_longer) + geom_rect(aes(xmin=position-0.005,xmax=position+0.005,ymin=0,ymax=1,fill=value)) + 
  facet_grid(rows=vars(seg_final_longer$isolate),
             cols=vars(seg_final_longer$contig),
             scales="free",space="free") +
  scale_fill_manual(values=c("cornflowerblue","red","orange2"))+
  theme_classic() + labs(x="Position (Mb)")+
  scale_x_continuous(breaks=c(0,1,2,3,4),expand=c(0.02,0.02))+
  scale_y_continuous(expand=c(0.05,0.05))+
  theme(strip.text.y=element_text(angle=0),
        axis.text.y=element_blank(),
        axis.ticks.y=element_blank(),
        axis.line.y = element_blank(),
        panel.background=element_rect("#F5F5F5","grey20",1.3))
dev.off()


#now we want to extract the information about the allele frequency from the remaining aneuploids
AO <- as.data.frame(extract.gt(hetdip,element="AO",as.numeric=T))
AO$contig <- gsub("_.*","",row.names(AO))
AO$position <- gsub(".*_","",row.names(AO))
AO <- AO[row.names(AO) %in% row.names(seg_final),]
RO <- as.data.frame(extract.gt(hetdip,element="RO",as.numeric=T))
RO$contig <- gsub("_.*","",row.names(RO))
RO$position <- gsub(".*_","",row.names(RO))
RO <- RO[row.names(RO) %in% row.names(seg_final),]

ratios <- data.frame(
  ZJH3 = AO$ZJH3/(AO$ZJH3+RO$ZJH3),
  hap12 = AO$hap12/(AO$hap12+RO$hap12),
  hap18 = AO$hap18/(AO$hap18+RO$hap18),
  hap23 = AO$hap23/(AO$hap23+RO$hap23),
  chr = AO$contig)

ratios_long <- pivot_longer(ratios,1:4,names_to="isolate")
ratios_long$isolate <- factor(ratios_long$isolate,levels=c("hap12","ZJH3","hap18","hap23"))
png("allele_ratios.png",width=800,height=350)
ggplot(ratios_long) + 
  geom_histogram(aes(x=value),bins=50) + 
  scale_x_continuous(breaks=c(0,0.25,0.5,0.75,1),labels=c("0","0.25","0.5","0.75","1"))+
  facet_grid(cols=vars(chr),rows=vars(isolate),scales="free_y") + 
  theme_bw() + 
  theme(panel.grid.minor.y=element_blank(),
        panel.grid.major.y=element_blank())+
  labs(x="Alternate Allele Ratio")
dev.off()
