


if(Sys.getenv("USERNAME")=="auxie001"){setwd("C:\\Users\\auxie001\\OneDrive - WageningenUR\\mitotic_recomb")}

#setwd("/Users/user/OneDrive\ -\ Wageningen\ University\ &\ Research/mitotic_recomb/")
# VCF Filtering -----------------------------------------------------------
library(vcfR)
library(ggplot2)
library(tidyr)
library(dplyr)
hetdip <- read.vcfR("niger.filt.vcf.gz")

gt <- as.data.frame(extract.gt(hetdip))

#First we filter to remove heterozygotes in the starting strains
het_test <- as.data.frame(is.het(extract.gt(hetdip)))

no_het <- gt[which(het_test$N522 == F & het_test$N502 == F & het_test$D0 == T),]

#collect which are 0/0 and 1/1 in focal strains
var_N502 <- which(no_het$N502 == "1/1" & no_het$N522 == "0/0")
var_N522 <- which(no_het$N502 == "0/0" & no_het$N522 == "1/1")

#now combine and sort
vars <- sort(c(var_N502,var_N522))
final <- no_het[vars,]
seg_final <- final[which(final$N502 != final$N522),]

row.names(seg_final) <- gsub("NT_","",row.names(seg_final))
seg_final$contig <- gsub("_.*","",row.names(seg_final))
seg_final$position <- gsub(".*_","",row.names(seg_final))

head(seg_final)

#now we polarize the variants
seg_final$H1[seg_final$N502 == "0/0" & seg_final$H1 == "0/0"] <- "A"
seg_final$H1[seg_final$N502 == "0/0" & seg_final$H1 == "1/1"] <- "B"
seg_final$H1[seg_final$N502 == "1/1" & seg_final$H1 == "0/0"] <- "B"
seg_final$H1[seg_final$N502 == "1/1" & seg_final$H1 == "1/1"] <- "A"

seg_final$H2[seg_final$N502 == "0/0" & seg_final$H2 == "0/0"] <- "A"
seg_final$H2[seg_final$N502 == "0/0" & seg_final$H2 == "1/1"] <- "B"
seg_final$H2[seg_final$N502 == "1/1" & seg_final$H2 == "0/0"] <- "B"
seg_final$H2[seg_final$N502 == "1/1" & seg_final$H2 == "1/1"] <- "A"

seg_final$H3[seg_final$N502 == "0/0" & seg_final$H3 == "0/0"] <- "A"
seg_final$H3[seg_final$N502 == "0/0" & seg_final$H3 == "1/1"] <- "B"
seg_final$H3[seg_final$N502 == "1/1" & seg_final$H3 == "0/0"] <- "B"
seg_final$H3[seg_final$N502 == "1/1" & seg_final$H3 == "1/1"] <- "A"

seg_final$H4[seg_final$N502 == "0/0" & seg_final$H4 == "0/0"] <- "A"
seg_final$H4[seg_final$N502 == "0/0" & seg_final$H4 == "1/1"] <- "B"
seg_final$H4[seg_final$N502 == "1/1" & seg_final$H4 == "0/0"] <- "B"
seg_final$H4[seg_final$N502 == "1/1" & seg_final$H4 == "1/1"] <- "A"

seg_final$H5[seg_final$N502 == "0/0" & seg_final$H5 == "0/0"] <- "A"
seg_final$H5[seg_final$N502 == "0/0" & seg_final$H5 == "1/1"] <- "B"
seg_final$H5[seg_final$N502 == "1/1" & seg_final$H5 == "0/0"] <- "B"
seg_final$H5[seg_final$N502 == "1/1" & seg_final$H5 == "1/1"] <- "A"

seg_final$H6[seg_final$N502 == "0/0" & seg_final$H6 == "0/0"] <- "A"
seg_final$H6[seg_final$N502 == "0/0" & seg_final$H6 == "1/1"] <- "B"
seg_final$H6[seg_final$N502 == "1/1" & seg_final$H6 == "0/0"] <- "B"
seg_final$H6[seg_final$N502 == "1/1" & seg_final$H6 == "1/1"] <- "A"

seg_final$H7[seg_final$N502 == "0/0" & seg_final$H7 == "0/0"] <- "A"
seg_final$H7[seg_final$N502 == "0/0" & seg_final$H7 == "1/1"] <- "B"
seg_final$H7[seg_final$N502 == "1/1" & seg_final$H7 == "0/0"] <- "B"
seg_final$H7[seg_final$N502 == "1/1" & seg_final$H7 == "1/1"] <- "A"

seg_final$H8[seg_final$N502 == "0/0" & seg_final$H8 == "0/0"] <- "A"
seg_final$H8[seg_final$N502 == "0/0" & seg_final$H8 == "1/1"] <- "B"
seg_final$H8[seg_final$N502 == "1/1" & seg_final$H8 == "0/0"] <- "B"
seg_final$H8[seg_final$N502 == "1/1" & seg_final$H8 == "1/1"] <- "A"

seg_final$H9[seg_final$N502 == "0/0" & seg_final$H9 == "0/0"] <- "A"
seg_final$H9[seg_final$N502 == "0/0" & seg_final$H9 == "1/1"] <- "B"
seg_final$H9[seg_final$N502 == "1/1" & seg_final$H9 == "0/0"] <- "B"
seg_final$H9[seg_final$N502 == "1/1" & seg_final$H9 == "1/1"] <- "A"

seg_final$H10[seg_final$N502 == "0/0" & seg_final$H10 == "0/0"] <- "A"
seg_final$H10[seg_final$N502 == "0/0" & seg_final$H10 == "1/1"] <- "B"
seg_final$H10[seg_final$N502 == "1/1" & seg_final$H10 == "0/0"] <- "B"
seg_final$H10[seg_final$N502 == "1/1" & seg_final$H10 == "1/1"] <- "A"

seg_final$H11[seg_final$N502 == "0/0" & seg_final$H11 == "0/0"] <- "A"
seg_final$H11[seg_final$N502 == "0/0" & seg_final$H11 == "1/1"] <- "B"
seg_final$H11[seg_final$N502 == "1/1" & seg_final$H11 == "0/0"] <- "B"
seg_final$H11[seg_final$N502 == "1/1" & seg_final$H11 == "1/1"] <- "A"

seg_final$H12[seg_final$N502 == "0/0" & seg_final$H12 == "0/0"] <- "A"
seg_final$H12[seg_final$N502 == "0/0" & seg_final$H12 == "1/1"] <- "B"
seg_final$H12[seg_final$N502 == "1/1" & seg_final$H12 == "0/0"] <- "B"
seg_final$H12[seg_final$N502 == "1/1" & seg_final$H12 == "1/1"] <- "A"

seg_final$H13[seg_final$N502 == "0/0" & seg_final$H13 == "0/0"] <- "A"
seg_final$H13[seg_final$N502 == "0/0" & seg_final$H13 == "1/1"] <- "B"
seg_final$H13[seg_final$N502 == "1/1" & seg_final$H13 == "0/0"] <- "B"
seg_final$H13[seg_final$N502 == "1/1" & seg_final$H13 == "1/1"] <- "A"

seg_final$H14[seg_final$N502 == "0/0" & seg_final$H14 == "0/0"] <- "A"
seg_final$H14[seg_final$N502 == "0/0" & seg_final$H14 == "1/1"] <- "B"
seg_final$H14[seg_final$N502 == "1/1" & seg_final$H14 == "0/0"] <- "B"
seg_final$H14[seg_final$N502 == "1/1" & seg_final$H14 == "1/1"] <- "A"

seg_final$H15[seg_final$N502 == "0/0" & seg_final$H15 == "0/0"] <- "A"
seg_final$H15[seg_final$N502 == "0/0" & seg_final$H15 == "1/1"] <- "B"
seg_final$H15[seg_final$N502 == "1/1" & seg_final$H15 == "0/0"] <- "B"
seg_final$H15[seg_final$N502 == "1/1" & seg_final$H15 == "1/1"] <- "A"

seg_final$H16[seg_final$N502 == "0/0" & seg_final$H16 == "0/0"] <- "A"
seg_final$H16[seg_final$N502 == "0/0" & seg_final$H16 == "1/1"] <- "B"
seg_final$H16[seg_final$N502 == "1/1" & seg_final$H16 == "0/0"] <- "B"
seg_final$H16[seg_final$N502 == "1/1" & seg_final$H16 == "1/1"] <- "A"

seg_final$H17[seg_final$N502 == "0/0" & seg_final$H17 == "0/0"] <- "A"
seg_final$H17[seg_final$N502 == "0/0" & seg_final$H17 == "1/1"] <- "B"
seg_final$H17[seg_final$N502 == "1/1" & seg_final$H17 == "0/0"] <- "B"
seg_final$H17[seg_final$N502 == "1/1" & seg_final$H17 == "1/1"] <- "A"

seg_final$H18[seg_final$N502 == "0/0" & seg_final$H18 == "0/0"] <- "A"
seg_final$H18[seg_final$N502 == "0/0" & seg_final$H18 == "1/1"] <- "B"
seg_final$H18[seg_final$N502 == "1/1" & seg_final$H18 == "0/0"] <- "B"
seg_final$H18[seg_final$N502 == "1/1" & seg_final$H18 == "1/1"] <- "A"

seg_final$H19[seg_final$N502 == "0/0" & seg_final$H19 == "0/0"] <- "A"
seg_final$H19[seg_final$N502 == "0/0" & seg_final$H19 == "1/1"] <- "B"
seg_final$H19[seg_final$N502 == "1/1" & seg_final$H19 == "0/0"] <- "B"
seg_final$H19[seg_final$N502 == "1/1" & seg_final$H19 == "1/1"] <- "A"

seg_final$H20[seg_final$N502 == "0/0" & seg_final$H20 == "0/0"] <- "A"
seg_final$H20[seg_final$N502 == "0/0" & seg_final$H20 == "1/1"] <- "B"
seg_final$H20[seg_final$N502 == "1/1" & seg_final$H20 == "0/0"] <- "B"
seg_final$H20[seg_final$N502 == "1/1" & seg_final$H20 == "1/1"] <- "A"

seg_final$H21[seg_final$N502 == "0/0" & seg_final$H21 == "0/0"] <- "A"
seg_final$H21[seg_final$N502 == "0/0" & seg_final$H21 == "1/1"] <- "B"
seg_final$H21[seg_final$N502 == "1/1" & seg_final$H21 == "0/0"] <- "B"
seg_final$H21[seg_final$N502 == "1/1" & seg_final$H21 == "1/1"] <- "A"

seg_final$H22[seg_final$N502 == "0/0" & seg_final$H22 == "0/0"] <- "A"
seg_final$H22[seg_final$N502 == "0/0" & seg_final$H22 == "1/1"] <- "B"
seg_final$H22[seg_final$N502 == "1/1" & seg_final$H22 == "0/0"] <- "B"
seg_final$H22[seg_final$N502 == "1/1" & seg_final$H22 == "1/1"] <- "A"

seg_final$D0[seg_final$N502 == "0/0" & seg_final$D0 == "0/0"] <- "A"
seg_final$D0[seg_final$N502 == "0/0" & seg_final$D0 == "1/1"] <- "B"
seg_final$D0[seg_final$N502 == "1/1" & seg_final$D0 == "0/0"] <- "B"
seg_final$D0[seg_final$N502 == "1/1" & seg_final$D0 == "1/1"] <- "A"

seg_final$DA[seg_final$N502 == "0/0" & seg_final$DA == "0/0"] <- "A"
seg_final$DA[seg_final$N502 == "0/0" & seg_final$DA == "1/1"] <- "B"
seg_final$DA[seg_final$N502 == "1/1" & seg_final$DA == "0/0"] <- "B"
seg_final$DA[seg_final$N502 == "1/1" & seg_final$DA == "1/1"] <- "A"

seg_final$DB[seg_final$N502 == "0/0" & seg_final$DB == "0/0"] <- "A"
seg_final$DB[seg_final$N502 == "0/0" & seg_final$DB == "1/1"] <- "B"
seg_final$DB[seg_final$N502 == "1/1" & seg_final$DB == "0/0"] <- "B"
seg_final$DB[seg_final$N502 == "1/1" & seg_final$DB == "1/1"] <- "A"

seg_final$DC[seg_final$N502 == "0/0" & seg_final$DC == "0/0"] <- "A"
seg_final$DC[seg_final$N502 == "0/0" & seg_final$DC == "1/1"] <- "B"
seg_final$DC[seg_final$N502 == "1/1" & seg_final$DC == "0/0"] <- "B"
seg_final$DC[seg_final$N502 == "1/1" & seg_final$DC == "1/1"] <- "A"

seg_final$N502[seg_final$N502 == "0/0"] <- "A"
seg_final$N502[seg_final$N502 == "1/1"] <- "A"
seg_final$N522[seg_final$N522 == "0/0"] <- "B"
seg_final$N522[seg_final$N522 == "1/1"] <- "B"


seg_final[seg_final == "0/1"] <- "A/B"

seg_final[seg_final %in% c("./0","./1","0/0","1/1","1/2","0/2","2/2","1/3","0/3")] <- NA


#### mapping contigs to chromosomes ####----
#>NT_166525.1 Aspergillus niger CBS 513.88 supercontig An09 | 1 c <-
#>NT_166529.1 Aspergillus niger CBS 513.88 supercontig An14 | 1 <- c
#>NT_166518.1 Aspergillus niger CBS 513.88 supercontig An01 | 2 c ->
#>NT_166528.1 Aspergillus niger CBS 513.88 supercontig An13 | 2 <- c
#>NT_166527.1 Aspergillus niger CBS 513.88 supercontig An12 | 3 <- c
#>NT_166530.1 Aspergillus niger CBS 513.88 supercontig An15 | 3 c ->
#>NT_166519.1 Aspergillus niger CBS 513.88 supercontig An02 | 4 c <-
#>NT_166523.1 Aspergillus niger CBS 513.88 supercontig An07 | 4 -> c
#>NT_166538.3 Aspergillus niger CBS 513.88 supercontig An19 | 4 c <- <-
#>NT_166537.1 Aspergillus niger CBS 513.88 supercontig An10 | 5 -> -> c
#>NT_166531.1 Aspergillus niger CBS 513.88 supercontig An16 | 5 c <-
#>NT_166532.1 Aspergillus niger CBS 513.88 supercontig An17 | 5 -> c
#>NT_166520.1 Aspergillus niger CBS 513.88 supercontig An03 | 6 c <-
#>NT_166539.1 Aspergillus niger CBS 513.88 supercontig An04 | 6 <- c
#>NT_166521.1 Aspergillus niger CBS 513.88 supercontig An05 | 7 <- c
#>NT_166526.1 Aspergillus niger CBS 513.88 clone An11       | 7 c <-
#>NT_166522.1 Aspergillus niger CBS 513.88 supercontig An06 | 8 c -> ->
#>NT_166524.1 Aspergillus niger CBS 513.88 supercontig An08 | 8 c ->
#>NT_166533.1 Aspergillus niger CBS 513.88 supercontig An18 | 8 -> c
#>NC_007445.1 Aspergillus niger mitochondrion, complete genome
#### END Mapping ####
#NT_166525 is 1595066 bases long
seg_final$position <- as.numeric(seg_final$position)
chr_1L <- subset(seg_final,contig=="166525.1") %>% mutate(position_new=1734209-position) %>% mutate(chr_new = "Chr1")
chr_1R <- subset(seg_final,contig=="166529.1") %>% mutate(position_new=1734209+1595066-position) %>% mutate(chr_new = "Chr1")

chr_2L <- subset(seg_final,contig=="166528.1") %>% mutate(position_new=908643-position) %>% mutate(chr_new = "Chr2")
chr_2R <- subset(seg_final,contig=="166518.1") %>% mutate(position_new=908643+position) %>% mutate(chr_new = "Chr2")

chr_3L <- subset(seg_final,contig=="166527.1") %>% mutate(position_new=2566738-position) %>% mutate(chr_new = "Chr3")
chr_3R <- subset(seg_final,contig=="166530.1") %>% mutate(position_new=2566738+position) %>% mutate(chr_new = "Chr3")

chr_4L <- subset(seg_final,contig=="166523.1") %>% mutate(position_new=position) %>% mutate(chr_new = "Chr4")
chr_4R <- subset(seg_final,contig=="166519.1") %>% mutate(position_new=2341370+3626085-position) %>% mutate(chr_new = "Chr4")
chr_4RR<- subset(seg_final,contig=="166538.1") %>% mutate(position_new=2341370+3626085+96468-position) %>% mutate(chr_new = "Chr4")

chr_5LL<- subset(seg_final,contig=="166537.1") %>% mutate(position_new=position) %>% mutate(chr_new = "Chr5")
chr_5L <- subset(seg_final,contig=="166532.1") %>% mutate(position_new=263333+position) %>% mutate(chr_new = "Chr5")
chr_5R <- subset(seg_final,contig=="166531.1") %>% mutate(position_new=263333+594599+2132688-position) %>% mutate(chr_new = "Chr5")

chr_6L <- subset(seg_final,contig=="166539.1") %>% mutate(position_new=2525243-position) %>% mutate(chr_new = "Chr6")
chr_6R <- subset(seg_final,contig=="166520.1") %>% mutate(position_new=2525243+1609811-position) %>% mutate(chr_new = "Chr6")

chr_7L <- subset(seg_final,contig=="166521.1") %>% mutate(position_new=603204-position) %>% mutate(chr_new = "Chr7")
chr_7R <- subset(seg_final,contig=="166526.1") %>% mutate(position_new=603204+2721467-position) %>% mutate(chr_new = "Chr7")

chr_8L <- subset(seg_final,contig=="166533.1") %>% mutate(position_new=position) %>% mutate(chr_new = "Chr8")
chr_8R <- subset(seg_final,contig=="166524.1") %>% mutate(position_new=1542301+position) %>% mutate(chr_new = "Chr8")
chr_8RR<- subset(seg_final,contig=="166522.1") %>% mutate(position_new=1542301+2925080+position) %>% mutate(chr_new = "Chr8")

seg_final <- rbind(chr_1L,chr_1R,chr_2L,chr_2R,
                   chr_3L,chr_3R,chr_4L,chr_4R,chr_4RR,
                   chr_5LL,chr_5L,chr_5R,chr_6L,chr_6R,
                   chr_7L,chr_7R,chr_8L,chr_8R,chr_8RR)

seg_final_longer <- pivot_longer(seg_final,1:27,names_to="isolate")
seg_final_longer$position_new <- as.numeric(seg_final_longer$position_new)/1000000

unique(seg_final_longer$value)

seg_final_longer$isolate <- factor(seg_final_longer$isolate,levels=c("N522","N502","D0","DA","DB","DC","H1","H2","H3","H4","H5","H6","H7","H8","H9","H10","H11","H12","H13","H14","H15","H16","H17","H18","H19","H20","H21","H22"
))

#seg_final_longer <- seg_final_longer[seg_final_longer$contig %in% c("tig00000001","tig00000006"),]

png(paste("a_nig_haploidized_genotypes",Sys.Date(),".png"),width=1500,height=750)
ggplot(seg_final_longer) + geom_rect(aes(xmin=position_new-0.02,xmax=position_new+0.02,ymin=0,ymax=1,fill=value)) + 
  facet_grid(rows=vars(seg_final_longer$isolate),
             cols=vars(seg_final_longer$chr_new),
             scales="free",space="free") +
  scale_fill_manual(values=c("cornflowerblue","red","orange2"))+
  theme_classic() + labs(x="Position (Mb)")+
  scale_x_continuous(breaks=c(0,1,2,3,4),expand=c(0.02,0.02))+
  scale_y_continuous(expand=c(0.05,0.05))+
  theme(strip.text.y=element_text(angle=0),
        axis.text.y=element_blank(),
        axis.ticks.y=element_blank(),
        axis.line.y = element_blank(),
        panel.background=element_rect("#F5F5F5","grey20",1.3))
dev.off()


# #now we want to extract the information about the allele frequency from the remaining aneuploids
# AO <- as.data.frame(extract.gt(hetdip,element="AO",as.numeric=T))
# AO$contig <- gsub("_.*","",row.names(AO))
# AO$position <- gsub(".*_","",row.names(AO))
# AO <- AO[row.names(AO) %in% row.names(seg_final),]
# RO <- as.data.frame(extract.gt(hetdip,element="RO",as.numeric=T))
# RO$contig <- gsub("_.*","",row.names(RO))
# RO$position <- gsub(".*_","",row.names(RO))
# RO <- RO[row.names(RO) %in% row.names(seg_final),]
# 
# ratios <- data.frame(
#   hap11 = AO$hap11/(AO$hap11+RO$hap11),
#   hap12 = AO$hap12/(AO$hap12+RO$hap12),
#   hap18 = AO$hap18/(AO$hap18+RO$hap18),
#   hap23 = AO$hap23/(AO$hap23+RO$hap23),
#   chr = AO$contig)
# 
# ratios_long <- pivot_longer(ratios,1:4,names_to="isolate")
# pdf("niger_haploidized_ratios.pdf",width=10,height=4)
# ggplot(ratios_long) + geom_histogram(aes(x=value),bins=50) + scale_x_continuous(breaks=c(0,0.25,0.5,0.75,1),labels=c("0","0.25","0.5","0.75","1"))+facet_grid(cols=vars(chr),rows=vars(isolate),scales="free_y") + theme_classic() + theme(panel.background=element_rect("#FAFAFA")) + labs(x="Alternate Allele Ratio")
# dev.off()
